package diffcad;

import java.awt.*;

class GratingTargetLine extends Shape {
    Target target;
    LaserWedgeLine lwl;
    double L = 81.139; // mm length of grating

    GratingTargetLine(LaserWedgeLine lwl_) {
        setColor(lwl_.getColor());
        target = new diffcad.Target();
        lwl = lwl_;
    }

    void up_date() {
        target.p1 =
                p1.intersect(
                        p2,
                        lwl.p1(),
                        lwl.p2()
                );
    }

    void draw(Graphics g) {
        pushGraphicsState(g);
        up_date();
        target.draw(g);
        line(g, p1, p2);
        popGraphicsState(g);
    }
}
