package gui;

import java.awt.*;

class EventTester extends ShortCutFrame {
    Menu m1 = new Menu("Event Menu");
    MenuItem item1_mi = addMenuItem(m1, "[1] Item");
    MenuItem item2_mi = addMenuItem(m1, "[M-2] Item");


    Menu hierarchicMenu = new Menu("Hierarchic Menu");
    MenuItem itemH1_mi = addMenuItem(hierarchicMenu, "[^1] Item");
    MenuItem itemH2_mi = addMenuItem(hierarchicMenu, "[^A-2] Item");
    MenuItem itemH3_mi = addMenuItem(hierarchicMenu, "[^M-A-3] Item");


    public static void main(String args[]) {
        EventTester et = new EventTester("Event Tester");
        et.initMenuBar();
        et.show();
    }

    EventTester(String title) {
        super(title);
    }

    public void initMenuBar() {
        MenuBar mb = new MenuBar();
        m1.add(hierarchicMenu);
        mb.add(m1);
        setMenuBar(mb);
    }


    public boolean handleEvent(Event e) {
        if (match(e, item1_mi))
            System.out.println("Item 1!");
        else if (match(e, item2_mi))
            System.out.println("Item 2!");
        else if (match(e, itemH1_mi))
            System.out.println("Item h1!");
        else if (match(e, itemH2_mi))
            System.out.println("Item h2!");
        else if (match(e, itemH3_mi))
            System.out.println("Item h3!");
        return super.handleEvent(e);
    }
}